%define name fcron
%define version 1.0.2
%define release 1mdk

Summary:   fcron is a task scheduler.
Name:      %{name}
Version:   %{version}
Release:   %{release}
Source0:   %{name}-%{version}.tar.bz2
Source1:   %{name}-%{version}-extra.tar.bz2
Source2:   %{name}16.xpm.bz2
Source3:   %{name}32.xpm.bz2
Source4:   %{name}48.xpm.bz2
BuildRoot: %{_tmppath}/%{name}-root
Prefix:    %{_prefix}
Copyright: GPL
Packager:  Max Heijndijk <cchq@wanadoo.nl>
Group:     System/Servers
URL:	   http://fcron.free.fr/
Patch0:    %{name}-%{version}-Makefile.in.patch.bz2

%description

Fcron is a task scheduler. It aims at replacing Vixie Cron, so it implements most
of its functionalities.
Contrary to Vixie Cron, fcron does not need your system to be up 7 days
a week, 24 hours a day : it also works well with systems which are
not running neither all the time nor regularly (contrary to anacrontab).

%prep
  [ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != / ] \
  && rm -rf ${RPM_BUILD_ROOT}

%setup -T -b 0
%setup -T -D -a 1
mv %{name}-%{version}-extra/fcrontab.example ./

%patch0

%configure --prefix=%{prefix} --mandir=%{_mandir}

%build
make OPTIM="${RPM_OPT_FLAGS}"

%install
  mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/bin
  mkdir -p ${RPM_BUILD_ROOT}%{_docdir}
  mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
  mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man{1,3,5,8}
  mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/init.d
  mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/rc{0,2,3,4,5,6}.d
  mkdir -p ${RPM_BUILD_ROOT}/var/spool/fcron
  mkdir -p ${RPM_BUILD_ROOT}%{_menudir}

  make install \
  ETC=${RPM_BUILD_ROOT}%{_sysconfdir} \
  DESTBIN=${RPM_BUILD_ROOT}%{_prefix}/bin \
  DESTSBIN=${RPM_BUILD_ROOT}%{_sbindir} \
  DESTMAN=${RPM_BUILD_ROOT}%{_mandir} \
  DESTDOC=${RPM_BUILD_ROOT}%{_docdir} \
  FCRONTABS=${RPM_BUILD_ROOT}/var/spool/fcron

  install -c -m 755 script/sysVinit-launcher ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/init.d/fcron

  for NUM in 2 3 4 5 ; do
    cd ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/rc$NUM.d/ ; ln -f -s ../init.d/fcron S40fcron
  done

  for NUM in 0 6 ; do
    cd ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/rc$NUM.d/ ; ln -f -s ../init.d/fcron K60fcron
  done

  cat << EOF > ${RPM_BUILD_ROOT}%{_menudir}/%{name}
?package(%{name}): needs="text" section="Configuration/Other" title="Fcrontab" longtitle="Edit fcrontab file" command="fcrontab -e" icon="fcron.xpm"
EOF

# mdk icons
install -d %buildroot/{%_miconsdir,%_liconsdir}
bzcat %{SOURCE2} > %buildroot/%_miconsdir/%name.xpm
bzcat %{SOURCE3} > %buildroot/%_iconsdir/%name.xpm
bzcat %{SOURCE4} > %buildroot/%_liconsdir/%name.xpm

%pre
  echo -e "Checking if \"fcron\" is in /etc/passwd ...\n"
  if ! grep -q "^fcron:" /etc/passwd > /dev/null; then
    if useradd -D 2> /dev/null; then
	echo -e "\nCreating new user fcron ...\n"
	useradd -c 'Dummy user for fcron' -M fcron
    elif adduser -D 2> /dev/null; then
	echo -e "\nCreating new user fcron ...\n"
	adduser -c 'Dummy user for fcron' -M fcron
    fi
  fi

%post
%_post_service %{name}
%{update_menus}

  if [ "$1" = "2" ]; then
    killall -TERM fcron
    FCRONTABS=/var/spool/fcron

    find ${FCRONTABS} -type f \( -name "*.orig" -a ! -name "root.orig" \) \
		      -exec chown fcron:fcron {} \; -exec chmod 640 {} \;

    [ -f %{_sysconfdir}/fcron.deny ] && chown fcron:fcron %{_sysconfdir}/fcron.deny
    [ -f %{_sysconfdir}/fcron.allow ] && chown fcron:fcron %{_sysconfdir}/fcron.allow

    %{_sysconfdir}/rc.d/init.d/fcron start

    for FILE in $FCRONTABS/* ; do
	if test "$FILE" != "$FCRONTABS/*" ; then
	    BASENAME=`basename ${FILE}`
	    FCRONTAB=`echo "${BASENAME}" | \
	    sed "s|.*orig|| ; s|new.*|| ; s|fcrontab.sig|| ; s|rm.*||"`
	    ( test ! -z "${FCRONTAB}" && fcrontab -u ${FCRONTAB} -z ) \
	    || echo -n ""
	fi
    done
  fi

%postun
  %{clean_menus}

%preun
%_preun_service  %{name}

%clean
  [ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != / ] \
  && rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root,755)
%doc doc/CHANGES doc/INSTALL doc/LICENSE doc/README doc/THANKS doc/*html fcrontab.example
%attr(640,root,fcron) %config(noreplace) %{_sysconfdir}/fcron.allow
%attr(640,root,fcron) %config(noreplace) %{_sysconfdir}/fcron.deny
%config(noreplace) %{_sysconfdir}/rc.d/init.d/fcron
%config(noreplace) %{_sysconfdir}/rc.d/rc*.d/*
%{_mandir}/man8/fcron.8*
%{_mandir}/man1/fcrontab.1*
%{_mandir}/man5/fcrontab.5*
%{_mandir}/man3/bitstring.3*
%attr(6111,fcron,fcron) %{_prefix}/bin/fcrontab
%attr(110,fcron,fcron) %{_sbindir}/fcron
%{_menudir}/*
%{_iconsdir}/*.xpm
%{_miconsdir}/*.xpm
%{_liconsdir}/*.xpm
%attr(770,fcron,fcron) /var/spool/fcron

%changelog
* Sun Apr  8 2001  Daouda Lo <daouda@mandrakesoft.com> 1.0.2-1mdk
- first mandrake build (spec from Max)
- add-ons (add build servers macros, icons ...) 
- request for testing ...

* Mon Mar 12 2001 Max Heijndijk <cchq@wanadoo.nl> 1.0.2-1
- Upgrade to 1.0.2
- Moved fcrontab.example to %doc

* Mon Feb 26 2001 Max Heijndijk <cchq@wanadoo.nl> 1.0.0-1
- Upgrade to 1.0.0

* Tue Feb 6 2001 Max Heijndijk <cchq@wanadoo.nl> 0.9.5-2
- Fixed permissions in postinstall-script

* Tue Feb 6 2001 Max Heijndijk <cchq@wanadoo.nl> 0.9.5-1
- Upgrade to 0.9.5

* Sat Feb 3 2001 Max Heijndijk <cchq@wanadoo.nl> 0.9.4-1
- Upgrade to 0.9.4

* Tue Nov 7 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.3-1
- Fixed exit status in postinstall script
- Upgrade to 0.9.3

* Fri Nov 3 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.2.1-3
- Fixed bug in postinstall script

* Thu Oct 26 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.2.1-2
- Added postinstall script to update fcrontabs

* Fri Sep 22 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.2.1-1
- Upgrade to 0.9.2.1

* Fri Sep 22 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.1-1
- Upgrade to 0.9.1

* Fri Aug 18 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.0-5
- Added menu entryfile

* Wed Aug 16 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.0-4
- Bzipped man pages

* Mon Aug 7 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.0-3
- Added example config-file.

* Sun Aug 6 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.0-2
- Added patch for initscript.
- Removed fcron-launcher patch.
- Added post and preun scripts.

* Sun Aug 6 2000 Max Heijndijk <cchq@wanadoo.nl> 0.9.0-1
- Initial wrap.
